| OpenCV 4.3.0 Open Source Computer Vision

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
cv::detail::BundleAdjusterBase Class Referenceabstract
Images stitching » Rotation Estimation

Base class for all camera parameters refinement methods. More...

`#include <opencv2/stitching/detail/motion_estimators.hpp>`

Inheritance diagram for cv::detail::BundleAdjusterBase:

## Public Member Functions
double | confThresh () const
const Mat | refinementMask () const
void | setConfThresh (double conf_thresh)
void | setRefinementMask (const Mat &mask)
void | setTermCriteria (const TermCriteria &term_criteria)
TermCriteria | termCriteria ()
Public Member Functions inherited from cv::detail::Estimator
virtual | ~Estimator ()
bool | operator() (const std::vector< ImageFeatures > &features, const std::vector< MatchesInfo > &pairwise_matches, std::vector< CameraParams > &cameras)
| Estimates camera parameters. More...

## Protected Member Functions
| BundleAdjusterBase (int num_params_per_cam, int num_errs_per_measurement)
| Construct a bundle adjuster base instance. More...
virtual void | calcError (Mat &err)=0
| Calculates error vector. More...
virtual void | calcJacobian (Mat &jac)=0
| Calculates the cost function jacobian. More...
virtual bool | estimate (const std::vector< ImageFeatures > &features, const std::vector< MatchesInfo > &pairwise_matches, std::vector< CameraParams > &cameras) CV_OVERRIDE
| This method must implement camera parameters estimation logic in order to make the wrapper detail::Estimator::operator()_ work. More...
virtual void | obtainRefinedCameraParams (std::vector< CameraParams > &cameras) const =0
| Gets the refined camera parameters. More...
virtual void | setUpInitialCameraParams (const std::vector< CameraParams > &cameras)=0
| Sets initial camera parameter to refine. More...

## Protected Attributes
Mat | cam_params_
double | conf_thresh_
std::vector< std::pair< int, int > > | edges_
const ImageFeatures * | features_
int | num_errs_per_measurement_
int | num_images_
int | num_params_per_cam_
const MatchesInfo * | pairwise_matches_
Mat | refinement_mask_
TermCriteria | term_criteria_
int | total_num_matches_

## Detailed Description

Base class for all camera parameters refinement methods.

## Constructor & Destructor Documentation

## ◆ BundleAdjusterBase()

cv::detail::BundleAdjusterBase::BundleAdjusterBase | ( | int | num_params_per_cam,
|  | int | num_errs_per_measurement
| ) |  |
| inline protected

Construct a bundle adjuster base instance.

Parameters

  num_params_per_cam | Number of parameters per camera
  num_errs_per_measurement | Number of error terms (components) per match

## Member Function Documentation

## ◆ calcError()

virtual void cv::detail::BundleAdjusterBase::calcError | ( | Mat & | err | ) |
| protected pure virtual

Calculates error vector.

Parameters

  err | Error column-vector of length total_num_matches * num_errs_per_measurement

## ◆ calcJacobian()

virtual void cv::detail::BundleAdjusterBase::calcJacobian | ( | Mat & | jac | ) |
| protected pure virtual

Calculates the cost function jacobian.

Parameters

  jac | Jacobian matrix of dimensions (total_num_matches * num_errs_per_measurement) x (num_images * num_params_per_cam)

## ◆ confThresh()

double cv::detail::BundleAdjusterBase::confThresh | ( |  | ) | const
| inline

Python:
| retval | = | cv.detail_BundleAdjusterBase.confThresh( |  | )

## ◆ estimate()

virtual bool cv::detail::BundleAdjusterBase::estimate | ( | const std::vector< ImageFeatures > & | features,
|  | const std::vector< MatchesInfo > & | pairwise_matches,
|  | std::vector< CameraParams > & | cameras
| ) |  |
| protected virtual

This method must implement camera parameters estimation logic in order to make the wrapper detail::Estimator::operator()_ work.

Parameters

  features | Features of images
  pairwise_matches | Pairwise matches of images
  cameras | Estimated camera parameters

Returns
  True in case of success, false otherwise

Implements cv::detail::Estimator.

## ◆ obtainRefinedCameraParams()

virtual void cv::detail::BundleAdjusterBase::obtainRefinedCameraParams | ( | std::vector< CameraParams > & | cameras | ) | const
| protected pure virtual

Gets the refined camera parameters.

Parameters

  cameras | Refined camera parameters

## ◆ refinementMask()

const Mat cv::detail::BundleAdjusterBase::refinementMask | ( |  | ) | const
| inline

Python:
| retval | = | cv.detail_BundleAdjusterBase.refinementMask( |  | )

## ◆ setConfThresh()

void cv::detail::BundleAdjusterBase::setConfThresh | ( | double | conf_thresh | ) |
| inline

Python:
| None | = | cv.detail_BundleAdjusterBase.setConfThresh( | conf_thresh | )

## ◆ setRefinementMask()

void cv::detail::BundleAdjusterBase::setRefinementMask | ( | const Mat & | mask | ) |
| inline

Python:
| None | = | cv.detail_BundleAdjusterBase.setRefinementMask( | mask | )

## ◆ setTermCriteria()

void cv::detail::BundleAdjusterBase::setTermCriteria | ( | const TermCriteria & | term_criteria | ) |
| inline

Python:
| None | = | cv.detail_BundleAdjusterBase.setTermCriteria( | term_criteria | )

## ◆ setUpInitialCameraParams()

virtual void cv::detail::BundleAdjusterBase::setUpInitialCameraParams | ( | const std::vector< CameraParams > & | cameras | ) |
| protected pure virtual

Sets initial camera parameter to refine.

Parameters

  cameras | Camera parameters

## ◆ termCriteria()

TermCriteria cv::detail::BundleAdjusterBase::termCriteria | ( |  | ) |
| inline

Python:
| retval | = | cv.detail_BundleAdjusterBase.termCriteria( |  | )

## Member Data Documentation

## ◆ cam_params_

Mat cv::detail::BundleAdjusterBase::cam_params_
| protected

## ◆ conf_thresh_

double cv::detail::BundleAdjusterBase::conf_thresh_
| protected

## ◆ edges_

std::vector<std::pair<int,int> > cv::detail::BundleAdjusterBase::edges_
| protected

## ◆ features_

const ImageFeatures* cv::detail::BundleAdjusterBase::features_
| protected

## ◆ num_errs_per_measurement_

int cv::detail::BundleAdjusterBase::num_errs_per_measurement_
| protected

## ◆ num_images_

int cv::detail::BundleAdjusterBase::num_images_
| protected

## ◆ num_params_per_cam_

int cv::detail::BundleAdjusterBase::num_params_per_cam_
| protected

## ◆ pairwise_matches_

const MatchesInfo* cv::detail::BundleAdjusterBase::pairwise_matches_
| protected

## ◆ refinement_mask_

Mat cv::detail::BundleAdjusterBase::refinement_mask_
| protected

## ◆ term_criteria_

TermCriteria cv::detail::BundleAdjusterBase::term_criteria_
| protected

## ◆ total_num_matches_

int cv::detail::BundleAdjusterBase::total_num_matches_
| protected

The documentation for this class was generated from the following file:

- opencv2/stitching/detail/motion_estimators.hpp